theory Test_Some
  imports "Isac.Build_Isac" "$ISABELLE_ISAC_TEST/Tools/isac/ADDTESTS/accumulate-val/Lucas_Interpreter"
begin 

ML \<open>open ML_System\<close>
ML \<open>
  open Kernel;
  open Math_Engine;
  open Test_Code;              Test_Code.init_calc @{context};
  open LItool;                 arguments_from_model;
  open Sub_Problem;
  open Fetch_Tacs;
  open Step
  open Env;
  open LI;                     scan_dn;
  open Istate;
  open Error_Pattern;
  open Error_Pattern_Def;
  open Specification;
  open Ctree;                  append_problem;
  open Pos;
  open Program;
  open Prog_Tac;
  open Tactical;
  open Prog_Expr;
  open Auto_Prog;              rule2stac;
  open Input_Descript;
  open Specify;
  open Specify;
  open Step_Specify;
  open Step_Solve;
  open Step;
  open Solve;                  (* NONE *)
  open ContextC;               transfer_asms_from_to;
  open Tactic;                 (* NONE *)
  open I_Model;
  open O_Model;
  open P_Model;                (* NONE *)
  open Rewrite;
  open Eval;                   get_pair;
  open TermC;
  open Rule;
  open Rule_Set;               Sequence;
  open Eval_Def
  open ThyC
  open ThmC_Def
  open ThmC
  open Rewrite_Ord
  open UnparseC;

  Know_Store.set_ref_last_thy @{theory};
  (*otherwise ERRORs in pbl-met-hierarchy.sml, refine.sml, evaluate.sml*)
\<close>

section \<open>code for copy & paste ===============================================================\<close>
ML \<open>
\<close> ML \<open>
"~~~~~ fun xxx , args:"; val () = ();
"~~~~~ and xxx , args:"; val () = ();
"~~~~~ from fun xxx \<longrightarrow>fun yyy \<longrightarrow>fun zzz , return:"; val () = ();
"~~~~~ continue fun xxx"; val () = ();
(*if*) (*then*); (*else*);   (*case*) (*of*);  (*return value*); (*in*) (*end*);
"xx"
^ "xxx"   (*+*) (*+++*) (*keep for continuing YYYYY*) (*isa*) (*isa2*) (**)
\<close> ML \<open> (*//----------- adhoc inserted n ----------------------------------------------------\\*)
(*//------------------ adhoc inserted n ----------------------------------------------------\\*)
(*\\------------------ adhoc inserted n ----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- adhoc inserted n ----------------------------------------------------//*)

val return_XXXXX = "XXXXX"
\<close> ML \<open> (*//----------- step into XXXXX -----------------------------------------------------\\*)
(*//------------------ step into XXXXX -----------------------------------------------------\\*)
\<close> ML \<open> (*------------- continuing XXXXX ------------------------------------------------------*)
(*-------------------- continuing XXXXX ------------------------------------------------------*)
(*\\------------------ step into XXXXX -----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- step into XXXXX -----------------------------------------------------//*)
val "XXXXX" = return_XXXXX;

(*/------------------- check entry to XXXXX -------------------------------------------------\*)
(*\------------------- check entry to XXXXX -------------------------------------------------/*)
(*/------------------- check within XXXXX ---------------------------------------------------\*)
(*\------------------- check within XXXXX ---------------------------------------------------/*)
(*/------------------- check result of XXXXX ------------------------------------------------\*)
(*\------------------- check result of XXXXX ------------------------------------------------/*)
(* final test ... ----------------------------------------------------------------------------*)

\<close> ML \<open> (*//----------- inserted hidden code ------------------------------------------------\\*)
(*//------------------ inserted hidden code ------------------------------------------------\\*)
(*\\------------------ inserted hidden code ------------------------------------------------//*)
\<close> ML \<open> (*\\----------- inserted hidden code ------------------------------------------------//*)

\<close> ML \<open> (*//----------- build fun XXXXX -----------------------------------------------------\\*)
(*//------------------ build fun XXXXX -----------------------------------------------------\\*)
(*\\------------------ build fun XXXXX -----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- build fun XXXXX -----------------------------------------------------//*)
\<close>
ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close>
text \<open>
  declare [[show_types]] 
  declare [[show_sorts]]
  find_theorems "?a <= ?a"
  
  print_theorems
  print_facts
  print_statement ""
  print_theory
  ML_command \<open>Pretty.writeln prt\<close>
  declare [[ML_print_depth = 999]]
  declare [[ML_exception_trace]]
\<close>

section \<open>===================================================================================\<close>
section \<open>=====  ============================================================================\<close>
ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close>

section \<open>===================================================================================\<close>
section \<open>===== simplify.sml ================================================================\<close>
ML \<open>
\<close> ML \<open>

\<close> ML \<open>
\<close> ML \<open>
\<close>

section \<open>===================================================================================\<close>
section \<open>===== Interpret/li-tool.sml =======================================================\<close>
ML \<open>
\<close> ML \<open>
(* Title:  Interpret/li-tool.sml
   Author: Walther Neuper 050908
   (c) copyright due to lincense terms.
*)
"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- fun implicit_take, fun get_first_argument -------------------------";
"----------- fun from_prog ---------------------------------------";
"----------- fun specific_from_prog ----------------------------";
"----------- fun de_esc_underscore -------------------------------";
"----------- fun go ----------------------------------------------";
"----------- fun formal_args -------------------------------------";
"----------- fun dsc_valT ----------------------------------------";
"----------- fun arguments_from_model ---------------------------------------";
"----------- fun init_pstate -----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";

val thy =  @{theory Isac_Knowledge};

\<close> ML \<open>
"----------- fun init_pstate -----------------------------------------------------------------";
"----------- fun init_pstate -----------------------------------------------------------------";
"----------- fun init_pstate -----------------------------------------------------------------";
(*
  This test is deeply nested (down into details of creating environments).
  In order to make Sidekick show the structure add to each
  *                    (*/...\*) and        (*\.../*)
  * a companion  > ML < (*/...\*) and > ML < (*\.../*)
  Note the wrong ^----^ delimiters.
*)
val fmz = ["Traegerlaenge L", "Streckenlast q_0", "Biegelinie y",
	     "Randbedingungen [y 0 = (0::real), y L = 0, M_b 0 = 0, M_b L = 0]",
	     "FunktionsVariable x", "GleichungsVariablen [c, c_2, c_3, c_4]",
	     "AbleitungBiegelinie dy"];
val (dI',pI',mI') = ("Biegelinie", ["Biegelinien"],
		     ["IntegrierenUndKonstanteBestimmen2"]);
val p = e_pos'; val c = [];
(*[], Pbl*)val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))]; val Model_Problem = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Traegerlaenge L" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Streckenlast q_0" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "Biegelinie y" = nxt
\<close> ML \<open>
(*/---broken elementwise input to lists---\* )
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; (*\<rightarrow>Add_Relation "Randbedingungen [y 0 = 0]", ERROR MISSING step: M_b 0 = 0*)
                                        (*isa* ) val Add_Relation "Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]" = nxt
                                        ( *isa2*) val Add_Relation "Randbedingungen [y 0 = 0]" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; (*\<rightarrow>Add_Relation "Randbedingungen [y L = 0, M_b 0 = 0, M_b L = 0]"*)
                                        (*isa*) val Specify_Theory "Biegelinie" = nxt
                                        (*isa2* ) val Add_Relation "Randbedingungen [y L = 0, M_b 0 = 0, M_b L = 0]" = nxt( **)
( *\---broken elementwise input to lists---/*)
\<close> ML \<open>
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Relation "Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["Biegelinien"] = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["IntegrierenUndKonstanteBestimmen2"] = nxt
(*[], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "FunktionsVariable x" = nxt
(*[], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "GleichungsVariablen [c, c_2, c_3, c_4]" = nxt
(*[], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "AbleitungBiegelinie dy" = nxt

\<close> text \<open> (*ERROR type_of: real/real list/(#) [c_4]*)
(*[], Met*)val return_Add_Given_AbleitungBieg
                                = me nxt p c pt;
\<close> ML \<open> (*/------------ step into me_Add_Given_AbleitungBieg --------------------------------\\*)
(*/------------------- step into me_Add_Given_AbleitungBieg --------------------------------\\*)

"~~~~~ fun me , args:"; val (tac, p, _(*NEW remove*), pt) = (nxt, p, c, pt);
      val ctxt = Ctree.get_ctxt pt p
val ("ok", (_, _, ptp as (pt, p))) =
  	    (*case*) Step.by_tactic tac (pt, p) (*of*);

\<close> text \<open> (*ERROR type_of: real/real list/(#) [c_4]*)
        (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
\<close> ML \<open>
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) =
  (p, ((pt, Pos.e_pos'), []) );
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

\<close> text \<open> (*ERROR type_of: real/real list/(#) [c_4]*)
           switch_specify_solve p_ (pt, ip);
\<close> ML \<open>
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
       (*if*) Pos.on_specification ([], state_pos) (*then*);

\<close> text \<open> (*ERROR type_of: real/real list/(#) [c_4]*)
           specify_do_next (pt, input_pos);
\<close> ML \<open>
"~~~~~ fun specify_do_next , args:"; val (ptp as (pt, (p, p_))) = (pt, input_pos);
    val (_, (p_', tac)) = Specify.find_next_step ptp
    val ist_ctxt =  Ctree.get_loc pt (p, p_)
val Tactic.Apply_Method mI =
    (*case*) tac (*of*);

\<close> text \<open> (*ERROR type_of: real/real list/(#) [c_4]*)
  	    LI.by_tactic (Tactic.Apply_Method' (mI, NONE, Istate.empty, ContextC.empty))
  	      ist_ctxt (pt, (p, p_'));
\<close> ML \<open>
"~~~~~ fun by_tactic , args:"; val ((Tactic.Apply_Method' (mI, _, _, _)), (_, ctxt), (pt, pos as (p, _))) =
  ((Tactic.Apply_Method' (mI, NONE, Istate.empty, ContextC.empty)), ist_ctxt, (pt, (p, p_')));
      val (itms, oris, probl) = case get_obj I pt p of (*STILL asms=[]*)
          PblObj {meth = itms, origin = (oris, _, _), probl, ...} => (itms, oris, probl)
        | _ => raise ERROR "LI.by_tactic Apply_Method': uncovered case get_obj"
      val {model, ...} = MethodC.from_store ctxt mI;
      val itms = if itms <> [] then itms else I_Model.complete oris probl [] model
;
(*+*)if (itms |> I_Model.to_string @{context}) = "[\n" ^
  "(1 ,[1] ,true ,#Given ,Cor Traegerlaenge L ,(l_l, [L])), \n" ^
  "(2 ,[1] ,true ,#Given ,Cor Streckenlast q_0 ,(q_q, [q_0])), \n" ^
  "(3 ,[1] ,true ,#Find ,Cor Biegelinie y ,(b_b, [y])), \n" ^
  "(4 ,[1] ,true ,#Relate ,Cor Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0] ,(r_b, [[y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]])), \n" ^
  "(5 ,[1] ,true ,#Given ,Cor FunktionsVariable x ,(fun_var, [x])), \n" ^
  "(6 ,[1] ,true ,#Given ,Cor GleichungsVariablen [c, c_2, c_3, c_4] ,(vs, [[c, c_2, c_3, c_4]])), \n" ^
  "(7 ,[1] ,true ,#Given ,Cor AbleitungBiegelinie dy ,(id_der, [dy]))]"
(*+*)then () else error "init_pstate: initial i_model changed";
(*+*)if (itms |> I_Model.penv_to_string @{context}) = "[" ^ (*to be eliminated*)
(*1*)"(l_l, [L]), " ^
(*2*)"(q_q, [q_0]), " ^
(*3*)"(b_b, [y]), " ^
(*4*)"(r_b, [[y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]]), " ^
(*5*)"(fun_var, [x]), " ^
(*6*)"(vs, [[c, c_2, c_3, c_4]]), " ^
(*7*)"(id_der, [dy])]"
(*+*)then () else error "init_pstate: initial penv changed";

\<close> text \<open> (*ERROR type_of: real/real list/(#) [c_4]*)
    (*case*)
    LItool.init_pstate ctxt (I_Model.OLD_to_TEST itms) mI (*of*);
\<close> ML \<open>(*//------------ step into init_pstate -----------------------------------------------\\*)
(*//------------------ step into init_pstate -----------------------------------------------\\*)
"~~~~~ fun init_pstate , args:"; val (ctxt, i_model, met_id) = (ctxt, (I_Model.OLD_to_TEST itms), mI);
    val (model_patt, program, prog, prog_rls, where_, where_rls) =
      case MethodC.from_store ctxt met_id of
        {model = model_patt, program = program as Rule.Prog prog, prog_rls, where_, where_rls,...}=>
          (model_patt, program, prog, prog_rls, where_, where_rls)

\<close> ML \<open>
    val return_of_max_variant = 
   I_Model.of_max_variant model_patt i_model;
\<close> ML \<open>(*///----------- step into of_max_variant --------------------------------------------\\*)
(*///----------------- step into of_max_variant --------------------------------------------\\*)
"~~~~~ fun of_max_variant , args:"; val (model_patt, i_model) = (model_patt, i_model);
    val all_variants =
        map (fn (_, variants, _, _, _) => variants) i_model
        |> flat
        |> distinct op =
    val variants_separated = map (filter_variants' i_model) all_variants
    val sums_corr = map (cnt_corrects) variants_separated
    val sum_variant_s = arrange_args1 sums_corr (1, all_variants)
    val (_, max_variant) = hd (*..crude decision, up to improvement *)
      (sort (fn ((i, _), (j, _)) => int_ord (i, j)) sum_variant_s)
    val i_model_max =
      filter (fn (_, variants, _ , _ ,_) => member (op =) variants max_variant) i_model
    val equal_descr_pairs = map (get_equal_descr i_model) model_patt |> flat
;
(*+*)if (equal_descr_pairs |> descr_pairs_to_string @{context}) = "[" ^
(*defined: in program+model--vvvv--,----------------------------------------- in problem ---vvv*)
  "((#Given, (Traegerlaenge, l_l)), (1, [1], true ,#Given, " ^ "(Cor_TEST Traegerlaenge L ,(l_l, [L]), Position.T))), " ^
  "((#Given, (Streckenlast, q_q)), (2, [1], true ,#Given, " ^
   "(Cor_TEST Streckenlast q_0 ,(q_q, [q_0]), Position.T))), " ^
  "((#Given, (FunktionsVariable, fun_var)), (5, [1], true ,#Given, " ^
   "(Cor_TEST FunktionsVariable x ,(fun_var, [x]), Position.T))), " ^
  "((#Given, (GleichungsVariablen, vs)), (6, [1], true ,#Given, " ^
   "(Cor_TEST GleichungsVariablen [c, c_2, c_3, c_4] ,(vs, [[c, c_2, c_3, c_4]]), Position.T))), " ^
  "((#Given, (AbleitungBiegelinie, id_der)), (7, [1], true ,#Given, " ^
   "(Cor_TEST AbleitungBiegelinie dy ,(id_der, [dy]), Position.T))), " ^
  "((#Find, (Biegelinie, b_b)), (3, [1], true ,#Find, (Cor_TEST Biegelinie y ,(b_b, [y]), Position.T))), " ^
  "((#Relate, (Randbedingungen, r_b)), (4, [1], true ,#Relate, " ^
   "(Cor_TEST Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0] ,(r_b, [[y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]]), Position.T)))]"
then () else error "of_max_variant: equal_descr_pairs CHANGED";
(*/////############### old test code ##################################################\\\\\\* )

    val env_subst =
           mk_env_subst_DEL equal_descr_pairs;
(*/------------------- ERRORs to remove in CS subsequent to "prepare 1 PIDE turn 11"-000----\* )
(*+*)if (     env_subst |> Subst.to_string @{context}) = "[\"\n" ^
(*ERRORs------^^^^^^^^^----------isa2: penv ---vvv----------------------..isa2, thus "correct"*)         
(*1*)"(l_l, L)\", \"\n" ^                  (* (l_l, [L]) *)
(*2*)"(q_q, q_0)\", \"\n" ^                (* (q_q, [q_0]) *)
(*3*)"(fun_var, x)\", \"\n" ^              (* (fun_var, [x]) *)
(*4*)"(vs, GleichungsVariablen)\", \"\n" ^ (* (vs, [[c, c_2, c_3, c_4]]) *)
(*5*)"(id_der, dy)\", \"\n" ^              (* (id_der, [dy]) *)
(*6*)"(b_b, y)\"]"                         (* (b_b, [y]) *)
(*7 missing*)                              (* (r_b, [[y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]]) *)
(*+*)then () else error "of_max_variant: env_subst BETTER ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? "
( *\------------------- ERRORs to remove ..--------------------------------------------------/*)

(*///----------------- step into mk_env_subst_DEL ------------------------------------------\\*)
"~~~~~ fun mk_env_subst_DEL , args:"; val (equal_descr_pairs) = (equal_descr_pairs);

(*///################# nth 1 equal_descr_pairs ############################################=\\*)
       val xxx = (fn ((_, (_, id)), (_, _, _, _, (feedb, _)))
        => (Pre_Conds.discern_feedback_subst id feedb) (*|> map fst (*rhs dropped*)|> map (pair id)*) ) (nth 1 equal_descr_pairs);
"~~~~~ fun xxx , args:"; val ((_, (_, id)), (_, _, _, _, (feedb, _))) = (nth 1 equal_descr_pairs);
(*--------------------------------------------------------------------------^^^----------------*)

 Pre_Conds.discern_feedback_subst id feedb;
"~~~~~ fun discern_feedback_subst , args:"; val (id, Cor_TEST ((descr, [ts]), _)) = (id, feedb);
      (*if*) TermC.is_list ts (*else*);
      val ts = [ts]
;
 Pre_Conds.discern_type_subst (descr, id) ts;
"~~~~~ fun discern_type_subst , args:"; val ((descr, id), ts) = ((descr, id), ts);
val _(*"real \<Rightarrow> una"*) =
  (*case*) type_of descr (*of*);
val return_discern_type_subst_1 = [(id, Library.the_single ts)]
(*\\\################# nth 1 equal_descr_pairs ############################################=//*)

(*///################# nth 4 equal_descr_pairs ############################################=\\*)
       val xxx = (fn ((_, (_, id)), (_, _, _, _, (feedb, _)))
        => (discern_feedback_subst id feedb) (*|> map fst (*rhs dropped*)|> map (pair id)*) ) (nth 1 equal_descr_pairs);
"~~~~~ fun xxx , args:"; val ((_, (_, id)), (_, _, _, _, (feedb, _))) = (nth 4 equal_descr_pairs);
(*--------------------------------------------------------------------------^^^----------------*)

 Pre_Conds.discern_feedback_subst id feedb;
"~~~~~ fun discern_feedback_subst , args:"; val (id, Cor_TEST ((descr, (*[*)ts(*]*)), _)) = (id, feedb);
(*+*)val (Free ("vs", _), "[[c], [c_2], [c_3], [c_4]]")
  = (id, ts |> UnparseC.terms @{context});

    (*if*) fold (curry and_) (map TermC.is_list ts) true (*then*);
      val ts = ts;

           discern_type_subst (descr, id) ts;
"~~~~~ fun discern_type_subst , args:"; val ((descr, id), ts) = ((descr, id), ts);
val (Type ("fun", [Type ("List.list", [Type ("Real.real", [])]), _])) =
  (*case*) type_of descr (*of*);
         (*if*) TermC.is_list (hd ts) (*then*);

val return_discern_type_subst_4 =
(*       if TermC.is_list (hd ts)
         then*) [(id, ts |> map TermC.the_single |> TermC.list2isalist HOLogic.realT)]
(*       else []*)
(*+*)val "[\"\n(vs, [c, c_2, c_3, c_4])\"]"
  = return_discern_type_subst_4 |> Subst.to_string @{context}

(*-------------------- contine discern_feedback_subst ----------------------------------------*)
val return_discern_feedback_subst_4 = return_discern_type_subst_4
(*-------------------- contine mk_env_subst_DEL ----------------------------------------------*)
val return_mk_env_subst_DEL_4 = return_discern_feedback_subst_4  
(*+*)val "[\"\n(vs, [c, c_2, c_3, c_4])\"]"
  = return_mk_env_subst_DEL_4 |> Subst.to_string @{context}
(*\\\################# nth 4 equal_descr_pairs ############################################=//*)

(*///################# nth 7 equal_descr_pairs ############################################=\\*)
       val xxx = (fn ((_, (_, id)), (_, _, _, _, (feedb, _)))
        => (discern_feedback_subst id feedb) (*|> map fst (*rhs dropped*)|> map (pair id)*) ) (nth 7 equal_descr_pairs);
"~~~~~ fun xxx , args:"; val ((_, (_, id)), (_, _, _, _, (feedb, _))) = (nth 7 equal_descr_pairs);
(*--------------------------------------------------------------------------^^^----------------*)

 Pre_Conds.discern_feedback_subst id feedb;
"~~~~~ fun discern_feedback_subst , args:"; val (id, Cor_TEST ((descr, (*[*)ts(*]*)), _)) = (id, feedb);
(*+*)val (Free ("r_b", _), "[[y 0 = 0], [y L = 0], [M_b 0 = 0], [M_b L = 0]]")
  = (id, ts |> UnparseC.terms @{context});

    (*if*) fold (curry and_) (map TermC.is_list ts) true (*then*);
      val ts = ts;

           discern_type_subst (descr, id) ts;
"~~~~~ fun discern_type_subst , args:"; val ((descr, id), ts) = ((descr, id), ts);
val (Type ("fun", [Type ("List.list", [Type ("HOL.bool", [])]), _])) =
  (*case*) type_of descr (*of*);
         (*if*) TermC.is_list (hd ts) (*then*);

val return_discern_type_subst_7 =
(*       if TermC.is_list (hd ts)
         then*) [(id, ts |> map TermC.the_single |> TermC.list2isalist HOLogic.boolT)]
(*       else []*)
(*+*)val "[\"\n(r_b, [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0])\"]"
  = return_discern_type_subst_7 |> Subst.to_string @{context}

(*-------------------- contine discern_feedback_subst ----------------------------------------*)
val return_discern_feedback_subst_7 = return_discern_type_subst_7
(*-------------------- contine mk_env_subst_DEL ----------------------------------------------*)
val return_mk_env_subst_DEL_7 = return_discern_type_subst_7
(*+*)val "[\"\n(r_b, [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0])\"]"
  = return_mk_env_subst_DEL_7 |> Subst.to_string @{context};
(*\\\################# nth 7 equal_descr_pairs ############################################=//*)

(*BEFORE correct (vs, [c, c_2, c_3, c_4])* )
(*+*)val "[\"\n(l_l, L)\", \"\n(q_q, q_0)\", \"\n(fun_var, x)\", \"\n(vs, vs)\", \"\n(id_der, dy)\", \"\n(b_b, y)\"]"
(*ERRORs still -----------------------------------------------------------^^^-------------------------------------, r_b*)
  = (env_subst |> Subst.to_string @{context})
*)
(*NOW only nth 7 is missing.. (but mk_env_eval_DEL completely broken)* )
(*+*)val "[\"\n(l_l, L)\", \"\n(q_q, q_0)\", \"\n(fun_var, x)\", \"\n(vs, [c, c_2, c_3, c_4])\", \"\n(id_der, dy)\", \"\n(b_b, y)\"]"
(*ERRORs still ---------------------------------------------------------------------------------------------------------------------, r_b*)
  = (env_subst |> Subst.to_string @ {context})
*)                            
(*+*)if (env_subst |> Subst.to_string @{context}) = "[\"\n" ^
(*1*)"(l_l, L)\", \"\n" ^
(*2*)"(q_q, q_0)\", \"\n" ^
(*3*)"(fun_var, x)\", \"\n" ^
(*4*)"(vs, [c, c_2, c_3, c_4])\", \"\n" ^
(*5*)"(id_der, dy)\", \"\n" ^
(*6*)"(b_b, y)\", \"\n" ^
(*7*)"(r_b, [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0])\"]"
(*+*)then () else error "env_subst CHANGED";


(*+*)if (i_model_max |> I_Model.to_string_TEST @{context}) = "[\n" ^
  "(1, [1], true ,#Given, (Cor_TEST Traegerlaenge L ,(l_l, [L]), Position.T)), \n" ^
  "(2, [1], true ,#Given, (Cor_TEST Streckenlast q_0 ,(q_q, [q_0]), Position.T)), \n" ^
  "(3, [1], true ,#Find, (Cor_TEST Biegelinie y ,(b_b, [y]), Position.T)), \n" ^
  "(4, [1], true ,#Relate, (Cor_TEST Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0] ,(r_b, [[y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]]), Position.T)), \n" ^
  "(5, [1], true ,#Given, (Cor_TEST FunktionsVariable x ,(fun_var, [x]), Position.T)), \n" ^
  "(6, [1], true ,#Given, (Cor_TEST GleichungsVariablen [c, c_2, c_3, c_4] ,(vs, [[c, c_2, c_3, c_4]]), Position.T)), \n" ^
  "(7, [1], true ,#Given, (Cor_TEST AbleitungBiegelinie dy ,(id_der, [dy]), Position.T))]"
(*+*)then () else error "i_model_max CHANGED";

(*||------------------ continue of_max_variant ---------------------------------------------\\*)

           mk_env_eval_DEL i_model_max;
(*///----------------- step into mk_env_eval_DEL -------------------------------------------\\*)
"~~~~~ fun mk_env_eval_DEL , args:"; val (i_singles) = (i_model_max);
       val xxx = (fn (_, _, _, _, (feedb, _)) => discern_feedback_subst id feedb);

(*///################# nth 1 i_model_max \<longrightarrow>[], <>[] only in maximum-example ##############=\\*)
"~~~~~ fun xxx , args:"; val (_, _, _, _, (feedb, _)) = nth 1 i_model_max;
(*---------------------------------------------------------^^^------------*)
(*+*)val "Cor_TEST Traegerlaenge L ,(l_l, [L])"
  = feedb |> I_Model.feedback_to_string'_TEST @{context};

           discern_feedback_subst id feedb;
"~~~~~ fun discern_feedback_subst , args:"; val (Model_Def.Cor_TEST ((descr, [ts]), _)) = (feedb);
      (*if*) TermC.is_list ts (*else*);
      val ts = (*if TermC.is_list ts then TermC.isalist2list ts else*) [ts];

 Pre_Conds.discern_type_eval descr ts;
"~~~~~ fun discern_type_eval , args:"; val (descr, ts) = (descr, ts);
val _(*"real \<Rightarrow> una"*) =
  (*case*) type_of descr (*of*) 
;
 Pre_Conds.discern_atoms ts;
"~~~~~ fun discern_atoms , args:"; val (ts) = (ts);
  (*if*) all_atoms ts (*then*);

val return_distinguish_ts_eval_1 =
    map (rpair TermC.empty (*dummy rhs*)) ts
(*-------------------- contine discern_type_subst --------------------------------------------*)
(*-------------------- contine discern_feedback_subst ----------------------------------------*)
(*-------------------- contine mk_env_eval_DEL -----------------------------------------------*)
val return_mk_env_subst_DEL_1
  = filter_out (fn (_, b) => b = TermC.empty) return_distinguish_ts_eval_1
(*+*)val [] = return_mk_env_subst_DEL_1
(*\\\################# nth 1 i_model_max \<longrightarrow>[], <>[] only in maximum-example ##############=//*)
(*\\\----------------- step into mk_env_eval_DEL -------------------------------------------//*)

(*|||----------------- contine of_max_variant ------------------------------------------------*)

(*  val env_eval = mk_env_eval_DEL  i_model_max*)
    val env_eval = mk_env_eval_DEL  i_model_max
(*+*)val [] = env_eval
val return_of_max_variant_step = (i_model_max, env_model, (env_subst, env_eval))
;
return_of_max_variant_step = return_of_max_variant
( *\\\\\############### old test code ##################################################//////*)
\<close> ML \<open>
(*\\\----------------- step into of_max_variant --------------------------------------------//*)
    val (_, env_model, (env_subst, env_eval)) = return_of_max_variant

(*|------------------- contine init_pstate ---------------------------------------------------*)
    val actuals = map snd env_model
(*+* )val "[L, q_0, x, [c, c_2, c_3, c_4], dy, y, [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]]"
  = actuals |> UnparseC.terms @{context}(**)
(*+*)val 7 = length actuals( **)
(*WRONG ----------------v-v--v---v--v---v--v---v-----------v-------v--v-------v--v---------v--v---------v*)
(*+*) val "[L, q_0, x, [[c], [c_2], [c_3], [c_4]], dy, y, [[y 0 = 0], [y L = 0], [M_b 0 = 0], [M_b L = 0]]]"
  = actuals |> UnparseC.terms @{context}
\<close> ML \<open>
    val formals = Program.formal_args prog
(*+*)val "[l_l, q_q, fun_var, b_b, r_b, vs, id_der]"
  = formals |> UnparseC.terms @{context}
(*+*)val 7 = length formals

\<close> ML \<open>
    val preconds = Pre_Conds.check_from_store ctxt where_rls where_ env_subst env_eval
\<close> text \<open> (*ERROR type_of: real/real list/(#) [c_4]*)
    val ctxt = ctxt |> ContextC.insert_assumptions (map snd (snd preconds));
    val ist = Istate.e_pstate
      |> Istate.set_eval prog_rls
      |> Istate.set_env_true (relate_args [] formals actuals ctxt prog met_id formals actuals)
\<close> text \<open> (*ERROR type_of: real/real list/(#) [c_4]*)
(*+*)(relate_args [] formals actuals ctxt prog met_id formals actuals)
\<close> text \<open>
val return_init_pstate = (Istate.Pstate ist, ctxt, program)
\<close> ML \<open>(*\\------------ step into init_pstate -----------------------------------------------//*)
(*\\------------------ step into init_pstate -----------------------------------------------//*)
\<close> ML \<open>(*\------------- step into me_Add_Given_AbleitungBieg --------------------------------//*)
(*\------------------- step into me_Add_Given_AbleitungBieg --------------------------------//*)
\<close> text \<open> (*\------------ step into me_Add_Given_AbleitungBieg --------------------------------//*)
val (p,_,f,nxt,_,pt) = return_Add_Given_AbleitungBieg;
                                                 val Apply_Method ["IntegrierenUndKonstanteBestimmen2"] = nxt

\<close> text \<open>
(* final test ... ----------------------------------------------------------------------------*)
(*+*)val ([], Met) = p
(*+*)val Apply_Method ["IntegrierenUndKonstanteBestimmen2"] = nxt

\<close> ML \<open>
\<close>

section \<open>===================================================================================\<close>
section \<open>=====  ============================================================================\<close>
ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close>

section \<open>code for copy & paste ===============================================================\<close>
ML \<open>
"~~~~~ fun xxx , args:"; val () = ();
"~~~~~ and xxx , args:"; val () = ();
"~~~~~ from fun xxx \<longrightarrow>fun yyy \<longrightarrow>fun zzz , return:"; val () = ();
"~~~~~ continue fun xxx"; val () = ();
(*if*) (*then*); (*else*);   (*case*) (*of*);  (*return value*); (*in*) (*end*);
"xx"
^ "xxx"   (*+*) (*+++*) (*keep for continuing YYYYY*) (*isa*) (*isa2*) (**)
\<close> ML \<open> (*//----------- adhoc inserted n ----------------------------------------------------\\*)
 (*//----------------- adhoc inserted n ----------------------------------------------------\\*)
(*\\------------------ adhoc inserted n ----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- adhoc inserted n ----------------------------------------------------//*)

\<close> ML \<open> (*//----------- step into XXXXX -----------------------------------------------------\\*)
(*//------------------ step into XXXXX -----------------------------------------------------\\*)
(*keep for continuing YYYYY*)
\<close> ML \<open> (*------------- continue XXXXX --------------------------------------------------------*)
(*-------------------- continue XXXXX --------------------------------------------------------*)
(*kept for continuing XXXXX*)
(*-------------------- stop step into XXXXX --------------------------------------------------*)
\<close> ML \<open> (*------------- stop step into XXXXX --------------------------------------------------*)
(*\\------------------ step into XXXXX -----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- step into XXXXX -----------------------------------------------------//*)

(*/------------------- check entry to XXXXX -------------------------------------------------\*)
(*\------------------- check entry to XXXXX -------------------------------------------------/*)
(*/------------------- check within XXXXX ---------------------------------------------------\*)
(*\------------------- check within XXXXX ---------------------------------------------------/*)
(*/------------------- check result of XXXXX ------------------------------------------------\*)
(*\------------------- check result of XXXXX ------------------------------------------------/*)
(* final test ... ----------------------------------------------------------------------------*)

\<close> ML \<open> (*//----------- inserted hidden code ------------------------------------------------\\*)
(*//------------------ inserted hidden code ------------------------------------------------\\*)
(*\\------------------ inserted hidden code ------------------------------------------------//*)
\<close> ML \<open> (*\\----------- inserted hidden code ------------------------------------------------//*)

\<close> ML \<open> (*//----------- build new fun XXXXX -------------------------------------------------\\*)
(*//------------------ build new fun XXXXX -------------------------------------------------\\*)
(*\\------------------ build new fun XXXXX -------------------------------------------------//*)
\<close> ML \<open> (*\\----------- build new fun XXXXX -------------------------------------------------//*)
\<close>
end
